'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Log = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _logger = require('./logger');

var _helpers = require('./helpers');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

if (_helpers.Helpers.isNode) {}

var Log = exports.Log = function () {
    //#region singleton
    function Log() {
        _classCallCheck(this, Log);

        this._logOnly = false;
        this._logModules = false;
        this.isDevelopmentMode = true;
        this.modeIsSet = false;
        this.fixedWidth = 0;
        this.instances = {};
        this.levels = [];
        this.modules = [];
    }

    _createClass(Log, [{
        key: 'setProductionMode',

        //#region public api
        value: function setProductionMode() {
            var _this = this;

            if (this.modeIsSet) {
                this.modeIsSet = false;
                throw '[ng2-logger] Production mode is already set';
            } else {
                this.modeIsSet = true;
                setTimeout(function () {
                    if (_this.modeIsSet && console !== void 0 && console.clear !== void 0) {
                        console.clear();
                        console.log = function () {};
                        console.error = function () {};
                        console.warn = function () {};
                        console.info = function () {};
                    }
                });
                this.isDevelopmentMode = false;
            }
        }
    }, {
        key: 'onlyModules',
        value: function onlyModules() {
            if (this._logModules) {
                throw '[ng2-logger] You should use funcion onlyModules only once';
            }
            if (!this._logModules) {
                this._logModules = true;
            }

            for (var _len = arguments.length, modules = Array(_len), _key = 0; _key < _len; _key++) {
                modules[_key] = arguments[_key];
            }

            if (modules.length === 0) return;
            this.modules = modules;
            // console.log('only log this', Log.modules)
            this.muteAllOtherModules();
        }
    }, {
        key: 'onlyLevel',
        value: function onlyLevel() {
            if (this._logOnly) {
                throw '[ng2-logger] You should use funcion onlyLevel only once';
            }
            if (!this._logOnly) {
                this._logOnly = true;
            }

            for (var _len2 = arguments.length, level = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
                level[_key2] = arguments[_key2];
            }

            this.levels = Array.isArray(level) ? level : [level];
            for (var logName in this.instances) {
                if (this.instances.hasOwnProperty(logName)) {
                    var element = this.instances[logName];
                    element['allowed'] = this.levels;
                }
            }
        }
        //#endregion

    }, {
        key: 'create',
        value: function create(name) {
            for (var _len3 = arguments.length, level = Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
                level[_key3 - 1] = arguments[_key3];
            }

            var i = void 0;
            if (Array.isArray(this.levels) && this.levels.length > 0) {
                level = this.levels;
            }
            if (this.instances[name] === void 0) {
                i = new Log.Logger(name, getRandomColor(), this.isDevelopmentMode, level, this.isMutedModule(name), this.levels.length > 0 ? this.fixedWidth : void 0);
                this.instances[name] = i;
            } else {
                i = this.instances[name];
            }
            return i;
        }
    }, {
        key: 'isMutedModule',
        value: function isMutedModule(moduleName) {
            if (this.modules.length == 0) return false;
            if (!_helpers.Helpers.contain(this.modules, moduleName)) return true;
            return false;
        }
    }, {
        key: 'muteAllOtherModules',
        value: function muteAllOtherModules() {
            for (var moduleName in this.instances) {
                if (!_helpers.Helpers.contain(this.modules, moduleName)) this.instances[moduleName].mute();
            }
        }
    }], [{
        key: 'create',
        value: function create(name) {
            var _Log$instance;

            for (var _len4 = arguments.length, level = Array(_len4 > 1 ? _len4 - 1 : 0), _key4 = 1; _key4 < _len4; _key4++) {
                level[_key4 - 1] = arguments[_key4];
            }

            return (_Log$instance = Log.instance).create.apply(_Log$instance, [name].concat(level));
        }
    }, {
        key: 'instance',
        get: function get() {
            if (!this._instance) {
                this._instance = new Log();
            }
            return this._instance;
        }
    }]);

    return Log;
}();
//#endregion


Log.Logger = _logger.Logger;
function getRandomColor() {
    var letters = '012345'.split('');
    var color = '#';
    color += letters[Math.round(Math.random() * 5)];
    letters = '0123456789ABCDEF'.split('');
    for (var i = 0; i < 5; i++) {
        color += letters[Math.round(Math.random() * 15)];
    }
    if (color === void 0) {
        return getRandomColor();
    }
    ;
    return color;
}
//# sourceMappingURL=log.js.map